︠ec8de948-0bb1-4fde-90ab-01768eb63521s︠
1+1
︡29f6bff9-d1c3-406c-aba7-b852bcd754fa︡{"stdout":"2\n"}︡{"done":true}︡
︠6b4a937f-673b-4790-8d58-b8c3f432f1bes︠
def Hanoi(S, f, t, n, snapshots=[]):
    if n==0:
        return

    other = [i for i in range(3) if i not in [f,t]][0]

    Hanoi(S,f,other, n-1, snapshots)

    S[t].append(S[f].pop())
    snapshots.append(deepcopy(S))

    Hanoi(S,other,t, n-1, snapshots)

def HanoiProcess(n):
    initial = [range(n,0,-1),[],[]]
    snapshots = [[range(n,0,-1),[],[]]]

    Hanoi(initial,0,2,n,snapshots)

    return snapshots

def draw_pegs(n):
    # vxs of pegs, other pegs are shifted by 2*(n+1)
    pole = [(n,0),(n+1,0),(n+1,n+1),(n,n+1)]
    # we begin by drawing the base
    background = polygon2d([(0,-2),(6*n+5,-2),(6*n+5,0),(0,0)],color='black')

    for i in range(3):
        #then we draw the pegs
        background += polygon2d([(a+2*i*(n+1),b) for a,b in pole],color='black')
    return background

def draw_snapshot(s,n):
    snapshot = draw_pegs(n)
    for i,pole in enumerate(s):
        for h,r in enumerate(pole):
            # We can think of x as a measure of the disk size.
            x = float(r)/n
            # Based on the size of the disk we choose a color from the colormap
            red,gre,blu,dumm = colormaps.cool(x)
            # We draw the disk. Height from the base is measured by h.
            # Disk will be a 2r+1 x 1 rectangle centered about the peg and at height h.
            snapshot += polygon2d([(n+2*i*(n+1)-r,h),(n+2*i*(n+1)+r+1,h),(n+2*i*(n+1)+r+1,h+1),(n+2*i*(n+1)-r,h+1)],rgbcolor=(red,gre,blu))
    return snapshot

def HanoiPlots(n):
    snapshots = HanoiProcess(n)

    return [draw_snapshot(s,n) for s in snapshots]

def HanoiAnimation(n):
    plots = HanoiPlots(n)

    return animate(plots, axes=False)
︡e9f2bd3f-9813-4030-bf9d-69ecdf81b2fc︡{"done":true}︡
︠a5365b7d-f1fa-494b-a388-6b4ad21fd0b9s︠
n=3
A=HanoiAnimation(5)
︡781c8a12-e854-41be-ab4f-e058e3270630︡{"done":true}︡
︠bf0aa546-708f-46bc-8141-1b62d14c681ds︠
A.show(delay=100)
︡e8387a6c-3c68-4676-a7fe-fc148beec63f︡{"file":{"filename":"/projects/eed1ae93-d17f-4057-942e-19f043f5e6c1/.sage/temp/compute4-us/23511/tmp_aaxB0p.webm","show":true,"text":null,"url":"/eed1ae93-d17f-4057-942e-19f043f5e6c1/raw/.sage/temp/compute4-us/23511/tmp_aaxB0p.webm"},"once":false}︡{"html":"<div align='center'></div>"}︡{"done":true}︡
︠fb9611bb-5875-4cf7-9b8b-20318ebc915es︠
A.show(delay=0.1)
︡a29b6eec-5060-4eb4-98b1-86b4a1876c56︡{"file":{"filename":"/projects/eed1ae93-d17f-4057-942e-19f043f5e6c1/.sage/temp/compute4-us/4641/tmp_BPPOnx.webm","show":true,"text":null,"url":"/eed1ae93-d17f-4057-942e-19f043f5e6c1/raw/.sage/temp/compute4-us/4641/tmp_BPPOnx.webm"},"once":false}︡{"html":"<div align='center'></div>"}︡{"done":true}︡
︠4497d966-621d-4071-a6cc-0fac8bd3abf6s︠
A.show(delay=0.5)
︡2fd1c103-8798-436e-be84-ccbe299b9a0c︡{"file":{"filename":"/projects/eed1ae93-d17f-4057-942e-19f043f5e6c1/.sage/temp/compute4-us/4641/tmp_9hbk7v.webm","show":true,"text":null,"url":"/eed1ae93-d17f-4057-942e-19f043f5e6c1/raw/.sage/temp/compute4-us/4641/tmp_9hbk7v.webm"},"once":false}︡{"html":"<div align='center'></div>"}︡{"done":true}︡
︠a41478fb-214a-4dca-9684-70da04cb4435s︠
draw_snap([[8,7,6,5,4,3,2,1],[],[]],8).show(axes=False)
︡0646beec-3493-472f-8dea-f07b57502102︡{"file":{"filename":"/projects/eed1ae93-d17f-4057-942e-19f043f5e6c1/.sage/temp/compute4-us/4641/tmp_nhNkUO.svg","show":true,"text":null,"uuid":"c2b684e2-8343-4af5-a9e1-e99e0e608267"},"once":false}︡{"html":"<div align='center'></div>"}︡{"done":true}︡
︠21128460-0209-40c7-b147-b009a2de51ae︠

︡45776018-51fe-4ad5-a994-029f33d2d4e2︡
︠0d4b511f-6880-4810-8a37-9800e9e8f305s︠
range(8,0,-1)
︡eb93dfe1-8409-4c5e-8dc2-b6be98a51b00︡{"stdout":"[8, 7, 6, 5, 4, 3, 2, 1]\n"}︡{"done":true}︡
︠2fb7bd49-7db9-4f06-97a0-f495ad8f1a5f︠









